#include <sys/types.h>
#include <sys/stat.h>
#include <fcntl.h>
#include <stdio.h>

#define MAXL 256
#define BUFDIM 1000

int main(int argc, char* argv[]) { 

  int fd, fd2; 
  int n;
  int i;
  int dim;
  int x, tot;
  int chunk;
  char tmp[MAXL];
  char buf[BUFDIM];

  if (argc != 3) {
    fprintf(stderr, "Uso: %s numero nomefile\n", argv[0]);
    exit(1);
  } 

  sscanf(argv[1], "%d", &n);

  if ((fd = open(argv[2], O_RDONLY)) < 0 ) {
    perror(argv[0]);
    exit(1);
  }

  if((dim = lseek(fd, 0, SEEK_END)) <0) {
    perror(argv[0]);
    exit(1);
  }
  lseek(fd, 0, SEEK_SET);
  chunk = dim / n;

  for(i=0; i<n-1; i++) {

    sprintf(tmp, "%s-part%d", argv[2], i);    
    if ((fd2 = open(tmp, O_WRONLY | O_CREAT | O_TRUNC, 0644)) < 0) {
      perror(argv[0]);
      exit(1);
    }

    tot = 0; 
    while((x = read(fd, buf, (chunk - tot < BUFDIM ? chunk - tot: BUFDIM))) > 0 && tot < chunk) {
      tot += write(fd2, buf, x);
    }
    close(fd2);
  }

  sprintf(tmp, "%s-part%d", argv[2], n-1);
  if ((fd2 = open(tmp, O_WRONLY | O_CREAT | O_TRUNC, 0644)) < 0) {
      perror(argv[0]);
      exit(1);
  }
  while((x = read(fd, buf, BUFDIM)) > 0)
    write(fd2, buf, x);
  
  return 0;
}
